﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    
    public partial class Form1 : Form
    {
        int iCount;
        string strOuputFolder; 
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i;
            iCount = 0;
            strOuputFolder = "";

             cbotrackstyle.Items.Add("Rectangle + Ellipse");
             cbotrackstyle.Items.Add("Thin Rectangle");
             cbotrackstyle.Items.Add("Ellipse");
             cbotrackstyle.Items.Add("Strong Rectangle");
             cbotrackstyle.SelectedIndex = 0;

             for( i = 0; i< axVideoCap1.GetDeviceCount() - 1 ; i++)
                 cbovideodevice.Items.Add(axVideoCap1.GetDeviceName((short)i));
   
             if ( cbovideodevice.Items.Count > 0)
                cbovideodevice.SelectedIndex = 0;
        
             for(i = 0; i < axVideoCap1.GetVideoInputCount() - 1 ; i++)
                cbovideoinput.Items.Add(axVideoCap1.GetVideoInputName((short)i));

             if(cbovideoinput.Items.Count > 0)
                cbovideoinput.SelectedIndex = 0;
        
             for( i = 0; i< axVideoCap1.GetVideoFormatCount() - 1 ; i++)
                cbovideoformat.Items.Add(axVideoCap1.GetVideoFormatName((short)i));

              if (cbovideoformat.Items.Count > 0)
                cbovideoformat.SelectedIndex = 0;
        

        }

        private void btnPreview_Click(object sender, EventArgs e)
        {
            axVideoCap1.Device = (short)cbovideodevice.SelectedIndex;
            axVideoCap1.VideoInput = (short)cbovideoinput.SelectedIndex;
            axVideoCap1.VideoFormat = (short)cbovideoformat.SelectedIndex;
            axVideoCap1.VideoStandard = (short)cbovideostand.SelectedIndex;
        
            axVideoCap1.EffectType = VIDEOCAPLib.MYVIDEOCAPEFFECTTYPE.VIDEOFX;
            axVideoCap1.EffectFxType = 4;

            if(chkshowbackproj.Checked)
                axVideoCap1.EffectFaceShowBackProjection(true);
            else
                axVideoCap1.EffectFaceShowBackProjection(false);
       
            axVideoCap1.EffectFaceTemplateFile("haarcascade_frontalface_alt.xml");
            axVideoCap1.Start();

             chkshowbackproj.Enabled = false;
        }

      
       
        private void axVideoCap1_Capturing(object sender, AxVIDEOCAPLib._DVideoCapEvents_CapturingEvent e)
        {

        }


        private void axVideoCap1_FaceDetected(object sender, AxVIDEOCAPLib._DVideoCapEvents_FaceDetectedEvent e)
        {
            listBox1.Items.Add("Face Detected");

            string str1;
            string str2;
            str1 = this.strOuputFolder;

            str2 = str1 + "\\" +  iCount.ToString() +".jpg";
        axVideoCap1.EffectFaceCaptureFileName(str2);

        iCount = iCount + 1;


        }

        private void cbotrackstyle_SelectedIndexChanged(object sender, EventArgs e)
        {
            axVideoCap1.EffectFaceTrackBoxStyle((short)cbotrackstyle.SelectedIndex);
        }

        private void button2_Click(object sender, EventArgs e)
        {
             Color myColor; 
            if(colorDialog1.ShowDialog() == DialogResult.OK)
            {
                myColor = colorDialog1.Color;
                axVideoCap1.EffectFaceTrackBoxColor(myColor.R, myColor.G, myColor.B);
            }
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
             axVideoCap1.Stop();
             chkshowbackproj.Enabled = true;


        }

        private void btnchange_Click(object sender, EventArgs e)
        {
            axVideoCap1.EffectFaceThreshold(Convert.ToInt16(txtblack.Text), Convert.ToInt16(txtgray.Text));

        }

        private void chkcapturetofile_CheckedChanged(object sender, EventArgs e)
        {
            if (chkcapturetofile.Checked)
            {
                if (this.strOuputFolder == "")
                    if (folderBrowserDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                        this.strOuputFolder = folderBrowserDialog1.SelectedPath;

                axVideoCap1.EffectFaceCaptureToFile(true);
            }
            else
                axVideoCap1.EffectFaceCaptureToFile(false);
                
        }

        private void chkcapturefaceonly_CheckedChanged(object sender, EventArgs e)
        {
            if (chkcapturefaceonly.Checked)
                axVideoCap1.EffectFaceCaptureFaceOnly(true);
            else
                axVideoCap1.EffectFaceCaptureFaceOnly(false);

        
        }


    }
}
